/* $Id: conf.c,v 1.2 2003/12/12 14:02:39 armin Exp $
 *
 * divactrl aix config
 *
 * (c) 2003 Cytronics & Melware
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/errno.h>

void SetGroupOptimization(int nr, int val)
{
	int fd;
	unsigned char dev[1024];
	unsigned char data[2];

	sprintf(dev, "/dev/DivasAdapter%d", nr);
	
	if ((fd = open(dev, O_RDWR)) < 0)
		return;
	
	data[0] = 'x';
	data[1] = (val) ? '1' : '0';

	write(fd, data, 2);
	
	close(fd);
}

void SetDynamicLayer1Down(int nr, int val)
{
	int fd;
	unsigned char dev[1024];
	unsigned char data[2];

	sprintf(dev, "/dev/DivasAdapter%d", nr);
	
	if ((fd = open(dev, O_RDWR)) < 0)
		return;
	
	data[0] = (val) ? '1' : '0';
	data[1] = 'x';

	write(fd, data, 2);
	
	close(fd);
}

void fixup_card_number(char *cn)
{
	int card = 1;
	FILE *fp;
	unsigned char sline[1024];
	unsigned char lname[256];

	if ((!cn) || (strlen(cn) < 1))
		return;

	if (isdigit(cn[0]))
		return;

	if ((fp = fopen("/dev/DivasINFO", "r")) != NULL) {
		sprintf(lname, "(%s)", cn);
		while(!feof(fp)) {
			fgets(sline, sizeof(sline), fp);
			if (feof(fp))
				break;
			if (strstr(sline, lname)) {
				card = atoi(sline);
				fprintf(stderr, "Logical Name %s converted to Adapter #%d\n", cn, card);
				break;
			}
		}
		fclose(fp);
	}
	
	sprintf(cn, "%d", card);
}
